gdjs._21305_37197_30028_38754Code = {};
gdjs._21305_37197_30028_38754Code.GDPlayer2Objects1= [];
gdjs._21305_37197_30028_38754Code.GDPlayer2Objects2= [];
gdjs._21305_37197_30028_38754Code.GDPlayerObjects1= [];
gdjs._21305_37197_30028_38754Code.GDPlayerObjects2= [];
gdjs._21305_37197_30028_38754Code.GDstarObjects1= [];
gdjs._21305_37197_30028_38754Code.GDstarObjects2= [];
gdjs._21305_37197_30028_38754Code.GDResetPointObjects1= [];
gdjs._21305_37197_30028_38754Code.GDResetPointObjects2= [];
gdjs._21305_37197_30028_38754Code.GDToastMessageObjects1= [];
gdjs._21305_37197_30028_38754Code.GDToastMessageObjects2= [];
gdjs._21305_37197_30028_38754Code.GDWallObjects1= [];
gdjs._21305_37197_30028_38754Code.GDWallObjects2= [];
gdjs._21305_37197_30028_38754Code.GDTipsObjects1= [];
gdjs._21305_37197_30028_38754Code.GDTipsObjects2= [];
gdjs._21305_37197_30028_38754Code.GDCancelObjects1= [];
gdjs._21305_37197_30028_38754Code.GDCancelObjects2= [];

gdjs._21305_37197_30028_38754Code.conditionTrue_0 = {val:false};
gdjs._21305_37197_30028_38754Code.condition0IsTrue_0 = {val:false};
gdjs._21305_37197_30028_38754Code.condition1IsTrue_0 = {val:false};


gdjs._21305_37197_30028_38754Code.userFunc0x8c0a40 = function(runtimeScene) {
"use strict";
if (runtimeScene.getTimeManager().isFirstFrame()) {
    runtimeScene.lastSendTime = new Date().getTime()
    runtimeScene.lastClearTime = new Date().getTime()

	function GameServer() {
        this.lastSendHash = {}
        this.actionMap = {
            '-4' : 'gamestart',
            '-3' : 'gameover',
            '-2' : 'disconnect',
            '-1' : 'init',
            '0' : 'update_player',
            '1' : 'key_pressed',
            '2' : 'toggle_model',
            '3' : 'player_die'
        }
        this.actionCodeMap = {}
        for (var key in this.actionMap) {
            this.actionCodeMap[this.actionMap[key]] = key
        }
	}

	GameServer.prototype.compareData = function (oldData, newData, resultArr = undefined) {
        var result = oldData == newData ? "" : newData
        if(resultArr) {
            resultArr.push(oldData == newData ? oldData : newData)
        }
        return result;
    }
    GameServer.prototype.getIntData = function (arr, def) {
        var data = arr.pop()
        if(data.length == 0) {
            return def
        }
        return parseInt(data);
    }
    GameServer.prototype.needSend = function(type, message) {
        var lastData = this.lastSendHash[type]
        var need = true
        this.lastSendHash[type] = message
        return lastData != message
    }
    GameServer.prototype.getLastSendData = function(type) {
        return this.lastSendHash[type] ? this.lastSendHash[type] : ""
    }
    
    GameServer.prototype.getAction = function(data) {
        return this.actionMap[data]
    }

    GameServer.prototype.getActionCode = function(data) {
        return this.actionCodeMap[data]
    }

	GameServer.prototype.isConnect = false
    GameServer.prototype.runtime = undefined
    GameServer.prototype.updateRuntime = function(n_runtime) {
        this.otherPlayer.clear()
        this.runtime = n_runtime
    }
    GameServer.prototype.getPlayer = function(playerId) {
        var player
        if(this.otherPlayer.containsKey(playerId)){
			player = this.otherPlayer.get(playerId);
		} else {
            player = this.runtime.createObject("Player2")
			this.otherPlayer.put(playerId, player);
        }
        return player;
    }

	// 发送一个动作
    GameServer.prototype.sendAction = function(type, object) {
        if(!this.isConnect)return;
        var isForce = true
        var action = this.getAction(type)
        var rawData = new Array()
        var arr = new Array()
        arr.push(this.getActionCode(type))
        arr.push(this.selfId)

        var lastData = this.getLastSendData(type).split(',')
        lastData.reverse()
        switch(type) {
            case 'update_player':
                arr.push(parseInt(object.getX()))
                arr.push(parseInt(object.getY()))
                arr.push(object.isFlippedX() ? 1 : 0)
                arr.push(object.getAnimation())
                break
            case 'key_pressed':
                isForce = false
                var actions = new Array()
                actions.push(object.getVariables().get("KeyPressedLeft").getAsNumber())
                actions.push(object.getVariables().get("KeyPressedRight").getAsNumber())
                actions.push(object.getVariables().get("KeyPressedJump").getAsNumber())
                arr.push(actions.join(':'))

                arr.push(object.isFlippedX() ? 1 : 0)
                arr.push(object.getAnimation())
                break
            case 'toggle_model':
                break
            case 'player_die':
                break
        }
        var pack = arr.join()
        if(isForce || this.needSend(type, pack)) {
            console.log(pack)
            this.socket.send(pack)
        }
    }

    // 接收一个动作
    GameServer.prototype.updateAction = function(data) {
    	var receive = new Array()
    	receive = data.split(",")
        receive.reverse()
    	
        var type = this.getAction(receive.pop())
        var playerId = receive.pop()
        var player
        
        if(type == 'init') {
            runtimeScene.getGame().getVariables().get('Identity').setNumber(receive.pop())
            this.selfId = playerId
			this.isConnect = true
			return;
		} else if(type == 'disconnect') {
            player = this.getPlayer(playerId)
			if(player) {
				player.deleteFromScene(this.runtime)
			}
            this.otherPlayer.remove(playerId)
			return
		} else if(type == 'gameover') {
            alert('同房的小伙伴经受不住打击跑路了')
			runtimeScene.getGame().getVariables().get('StartGame').setNumber(0);
			return
	    } else if(type == 'gamestart') {
			runtimeScene.getGame().getVariables().get('StartGame').setNumber(1);
			return
		}

        switch(type) {
            case 'update_player':
                player = this.getPlayer(playerId)
                var platformer = player.getBehavior("PlatformerObject")
                var lastX = player.getX()
                var lastY = player.getY()
                var newX = this.getIntData(receive, player.getX())
                var newY = this.getIntData(receive, player.getY())
                // player.setX(newX)
                // player.setY(newY)
                if(Math.abs(lastX - newX) > 15) {
                    player.setX(newX)
                } else if(Math.abs(lastY - newY) > 15) {
                    player.setY(newY)
                }
		        player.flipX(this.getIntData(receive, player.isFlippedX() ? 1 : 0) == 1)
		        player.setAnimation(this.getIntData(receive, player.getAnimation()))
                break
            case 'key_pressed':
                // 按键由:分割，下标 0-左，1-右，2-跳，内容1=按下，0=未按下
                var actions = receive.pop().split(':')
                player = this.getPlayer(playerId)
                player.flipX(receive.pop() == 1)
		        player.setAnimation(receive.pop())
                for(var i = 0; i< actions.length; i++) {
                    switch(i) {
                        case 0:
                            player.getVariables().get("KeyPressedLeft").setNumber(actions[i])
                            break
                        case 1:
                            player.getVariables().get("KeyPressedRight").setNumber(actions[i])
                            break
                        case 2:
                            player.getVariables().get("KeyPressedJump").setNumber(actions[i])
                            break
                    }
                }
                break
            case 'toggle_model':
                var model = runtimeScene.getGame().getVariables().get('Model').getAsNumber()
                runtimeScene.getGame().getVariables().get('Model').setNumber(model == 0 ? 1 : 0);
                break
            case 'player_die':
                player = this.getPlayer(playerId)
                var reset = this.runtime.getObjects('ResetPoint')[0]
                player.setX(reset.getX())
                player.setY(reset.getY())
                break
        }
    }

	GameServer.prototype.connect = function() {
	    if (runtimeScene.getTimeManager().isFirstFrame()) {
		    this.otherPlayer = new Hashtable();
	        // this.socket = new WebSocket("ws://192.168.0.102:10808");
            this.socket = new WebSocket("ws://47.102.97.78:10808/game01-v1/");
		    var that = this;
		    this.socket.onmessage = function (event) {
                var message = event.data
                if(window.server) {
                    window.server.updateAction(message)
                }
	    	};
            this.socket.onclose = function (event) {
                
	    	};
            this.socket.onerror = function() {
                alert('与服务器连接异常，可能是网络波动或服务器维护中！')
                this.isConnect = false
                runtimeScene.getGame().getVariables().get('StartGame').setNumber(0)
                window.server = undefined
            }
	    }
	}
	
	if (runtimeScene.getTimeManager().isFirstFrame() && !window.server) {
		window.server = new GameServer()
	}
}

if(window.server && window.server.isConnect) {
    window.server.runtime = runtimeScene
	const players = runtimeScene.getObjects("Player");
    if(players.length > 0) {
        window.server.sendAction('key_pressed', players[0])

        var curr = new Date().getTime()
        if((curr - runtimeScene.lastSendTime) > 2000) {
            runtimeScene.lastSendTime = curr
            window.server.sendAction('update_player', players[0])
        }
        // if((curr - runtimeScene.lastClearTime) > 300) {
        //     runtimeScene.lastClearTime = curr
        //     window.server.lastSendHash = {}
        // }
    }
}
};
gdjs._21305_37197_30028_38754Code.mapOfGDgdjs_46_9521305_9537197_9530028_9538754Code_46GDCancelObjects1Objects = Hashtable.newFrom({"Cancel": gdjs._21305_37197_30028_38754Code.GDCancelObjects1});gdjs._21305_37197_30028_38754Code.eventsList0x5b6e48 = function(runtimeScene) {

{



}


{


gdjs._21305_37197_30028_38754Code.userFunc0x8c0a40(runtimeScene);

}


{


gdjs._21305_37197_30028_38754Code.condition0IsTrue_0.val = false;
{
gdjs._21305_37197_30028_38754Code.condition0IsTrue_0.val = gdjs.evtTools.runtimeScene.sceneJustBegins(runtimeScene);
}if (gdjs._21305_37197_30028_38754Code.condition0IsTrue_0.val) {
gdjs._21305_37197_30028_38754Code.GDPlayerObjects1.createFrom(runtimeScene.getObjects("Player"));
{for(var i = 0, len = gdjs._21305_37197_30028_38754Code.GDPlayerObjects1.length ;i < len;++i) {
    gdjs._21305_37197_30028_38754Code.GDPlayerObjects1[i].setAnimation(1);
}
}{runtimeScene.getGame().getVariables().getFromIndex(3).setNumber(0);
}{runtimeScene.getGame().getVariables().getFromIndex(2).setNumber(1);
}{gdjs.evtsExt__Network__Connect.func(runtimeScene, (typeof eventsFunctionContext !== 'undefined' ? eventsFunctionContext : undefined));
}}

}


{


gdjs._21305_37197_30028_38754Code.condition0IsTrue_0.val = false;
{
gdjs._21305_37197_30028_38754Code.condition0IsTrue_0.val = gdjs.evtsExt__Network__StartGame.func(runtimeScene, (typeof eventsFunctionContext !== 'undefined' ? eventsFunctionContext : undefined));
}if (gdjs._21305_37197_30028_38754Code.condition0IsTrue_0.val) {
{gdjs.evtTools.runtimeScene.replaceScene(runtimeScene, "第一关", true);
}}

}


{

gdjs._21305_37197_30028_38754Code.GDCancelObjects1.createFrom(runtimeScene.getObjects("Cancel"));

gdjs._21305_37197_30028_38754Code.condition0IsTrue_0.val = false;
{
gdjs._21305_37197_30028_38754Code.condition0IsTrue_0.val = gdjs.evtTools.input.cursorOnObject(gdjs._21305_37197_30028_38754Code.mapOfGDgdjs_46_9521305_9537197_9530028_9538754Code_46GDCancelObjects1Objects, runtimeScene, true, false);
}if (gdjs._21305_37197_30028_38754Code.condition0IsTrue_0.val) {
{gdjs.evtTools.runtimeScene.replaceScene(runtimeScene, "主界面", true);
}}

}


}; //End of gdjs._21305_37197_30028_38754Code.eventsList0x5b6e48


gdjs._21305_37197_30028_38754Code.func = function(runtimeScene) {
runtimeScene.getOnceTriggers().startNewFrame();

gdjs._21305_37197_30028_38754Code.GDPlayer2Objects1.length = 0;
gdjs._21305_37197_30028_38754Code.GDPlayer2Objects2.length = 0;
gdjs._21305_37197_30028_38754Code.GDPlayerObjects1.length = 0;
gdjs._21305_37197_30028_38754Code.GDPlayerObjects2.length = 0;
gdjs._21305_37197_30028_38754Code.GDstarObjects1.length = 0;
gdjs._21305_37197_30028_38754Code.GDstarObjects2.length = 0;
gdjs._21305_37197_30028_38754Code.GDResetPointObjects1.length = 0;
gdjs._21305_37197_30028_38754Code.GDResetPointObjects2.length = 0;
gdjs._21305_37197_30028_38754Code.GDToastMessageObjects1.length = 0;
gdjs._21305_37197_30028_38754Code.GDToastMessageObjects2.length = 0;
gdjs._21305_37197_30028_38754Code.GDWallObjects1.length = 0;
gdjs._21305_37197_30028_38754Code.GDWallObjects2.length = 0;
gdjs._21305_37197_30028_38754Code.GDTipsObjects1.length = 0;
gdjs._21305_37197_30028_38754Code.GDTipsObjects2.length = 0;
gdjs._21305_37197_30028_38754Code.GDCancelObjects1.length = 0;
gdjs._21305_37197_30028_38754Code.GDCancelObjects2.length = 0;

gdjs._21305_37197_30028_38754Code.eventsList0x5b6e48(runtimeScene);
return;

}

gdjs['_21305_37197_30028_38754Code'] = gdjs._21305_37197_30028_38754Code;
